package net.jhorstmann.jsonp.main;

import net.jhorstmann.jsonp.xml.JsonXMLReader;
import java.io.StringReader;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.stream.StreamResult;
import org.xml.sax.InputSource;
import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.SAXNotSupportedException;

public class Main {

    public static void main(String[] args) throws TransformerConfigurationException, TransformerException, SAXNotRecognizedException, SAXNotSupportedException {
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer t = tf.newTransformer();
        t.setOutputProperty(OutputKeys.INDENT, "yes");
        try {
            t.setOutputProperty("{http://xml.apache.org/xalan}indent-amount", "4");
        } catch (IllegalArgumentException ex) {
        }
        InputSource is = new InputSource(new StringReader("{\"foo\": [true, false, null, 1.23, {\"bar\": \"spam\", \"foo\": [ ], \"baz\": {}}]}"));
        //InputSource is = new InputSource(new StringReader("{\"foo\": [], \"bar\": []}"));
        //InputSource is = new InputSource(new StringReader("{\"foo\": [[[]]]}"));
        //InputSource is = new InputSource(new StringReader("[[],[]]"));
        JsonXMLReader reader = new JsonXMLReader();
        t.transform(new SAXSource(reader, is), new StreamResult(System.out));
    }
}
