package net.jhorstmann.jsonp.main;

import net.jhorstmann.jsonp.xml.JsonHandler;
import java.io.IOException;
import java.io.StringReader;
import javax.json.JsonStructure;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

public class Main2 {

    private static final String XML = "<object>"
            + "<member name='foo'>"
            + "<array>"
            + "<test/>"
            + "<boolean>true</boolean>"
            + "<null/>"
            + "<number>1.23</number>"
            + "<object>"
            + "<member name='bar'>"
            + "<string>spam</string>"
            + "</member>"
            + "</object>"
            + "</array>"
            + "</member>"
            + "</object>";

    //private static final String XML = "<array><number>123</number></array>";

    public static void main(String[] args) throws SAXException, ParserConfigurationException, IOException {
        SAXParserFactory factory = SAXParserFactory.newInstance();
        factory.setNamespaceAware(true);
        factory.setValidating(false);
        SAXParser parser = factory.newSAXParser();
        XMLReader reader = parser.getXMLReader();
        JsonHandler handler = new JsonHandler(reader);
        reader.setContentHandler(handler);
        InputSource is = new InputSource();
        is.setCharacterStream(new StringReader(XML));
        reader.parse(is);
        JsonStructure structure = handler.getStructure();
        System.out.println(structure);
    }
}
