package net.jhorstmann.jsonp.xmlutil;

import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

public abstract class TextContentHandler extends NestedContentHandler {

    private final StringBuilder text;

    public TextContentHandler(XMLReader reader, NestedContentHandler parent, int initialCapacity) {
        super(reader, parent);
        this.text = new StringBuilder(initialCapacity);
    }

    public TextContentHandler(XMLReader reader, NestedContentHandler parent) {
        this(reader, parent, 32);
    }

    @Override
    public void characters(char[] ch, int start, int length) throws SAXException {
        text.append(ch, start, length);
    }

    public void clearBuffer() {
        text.setLength(0);
    }

    public String getText() {
        return text.toString();
    }
}
